(* ************************************** *
 *       Abstraction over theorems        * 
 *       from the theory of lists.        *
 * ************************************** *)

fun abs_thm(absnm, thm) = 
    (tracing ("Abstracting "^Thm.name_of_thm thm^":"); 
     bind_thm(absnm, AbsTac.full_abs thm));

abs_thm("abs_not_Cons_self", not_Cons_self);

abs_thm("abs_not_Cons_self2", not_Cons_self2);

abs_thm("abs_neq_Nil_conv", neq_Nil_conv);

abs_thm("abs_length_induct", length_induct);

(* abs_thm("abs_lists_mono", lists_mono);
  FIXME: *** Unknown theorem "Set.mem_Collect_eq_iff2"
*)

abs_thm("abs_listsE", listsE);

abs_thm("abs_lists_IntI", lists_IntI);

abs_thm("abs_lists_Int_eq", lists_Int_eq);

abs_thm("abs_append_in_lists_conv", append_in_lists_conv);

abs_thm("abs_length_append", length_append);

abs_thm("abs_length_map", length_map);

abs_thm("abs_length_rev", length_rev);

abs_thm("abs_length_tl", length_tl);

abs_thm("abs_length_0_conv", length_0_conv);

abs_thm("abs_length_greater_0_conv", length_greater_0_conv);

abs_thm("abs_Suc_conv", length_Suc_conv);

abs_thm("abs_append_assoc", append_assoc);

abs_thm("abs_append_Nil2", append_Nil2);

abs_thm("abs_append_is_Nil_conv", append_is_Nil_conv);

abs_thm("abs_Nil_is_append_conv", Nil_is_append_conv);

abs_thm("abs_append_self_conv", append_self_conv);

abs_thm("abs_self_append_conv", self_append_conv);

abs_thm("abs_append_eq_append_conv", append_eq_append_conv);

abs_thm("abs_same_append_eq", same_append_eq);

abs_thm("abs_append1_eq_conv", append1_eq_conv);

abs_thm("abs_append_same_eq", append_same_eq);

(* abs_thm("abs_self_append_conv2", self_append_conv2);
   FIXME: *** Unknown theorem "List.self_append_conv_iff2"
*)

abs_thm("abs_hd_Cons_tl", hd_Cons_tl);

abs_thm("abs_hd_append", hd_append);

abs_thm("abs_hd_append2", hd_append2);

abs_thm("abs_tl_append", tl_append);

abs_thm("abs_tl_append2", tl_append2);

abs_thm("abs_eq_Nil_appendI", eq_Nil_appendI);

abs_thm("abs_Cons_eq_appendI", Cons_eq_appendI);

abs_thm("abs_append_eq_appendI", append_eq_appendI);

abs_thm("abs_map_ext", map_ext);

abs_thm("abs_map_ident", map_ident);

abs_thm("abs_map_append", map_append);

abs_thm("abs_map_compose", map_compose);

abs_thm("abs_rev_map", rev_map);

(* abs_thm("abs_map_eq_conv", map_eq_conv);
   FIXME: *** NOT FOUND! 
*)

abs_thm("abs_map_cong", map_cong);

abs_thm("abs_map_is_Nil_conv", map_is_Nil_conv);

abs_thm("abs_Nil_is_map_conv", Nil_is_map_conv);

(* abs_thm("abs_map_eq_Cons", map_eq_Cons);   
  FIXME:  *** Unknown theorem(s) "map_eq_Cons"
*)
(* abs_thm("abs_map_injective", map_injective);
   FIXME: *** Unknown theorem "List.list.inject_iff2"
*)

abs_thm("abs_inj_mapI", inj_mapI);

abs_thm("abs_inj_mapD", inj_mapD);

(* abs_thm("abs_inj_map", inj_map);
   FIXME: *** Unknown theorem "List.inj_mapD_dest"
*)

abs_thm("abs_rev_append", rev_append);

abs_thm("abs_rev_rev_ident", rev_rev_ident);

abs_thm("abs_rev_is_Nil_conv", rev_is_Nil_conv);

abs_thm("abs_Nil_is_rev_conv", Nil_is_rev_conv);

abs_thm("abs_rev_is_rev_conv", rev_is_rev_conv);

abs_thm("abs_rev_induct", rev_induct);

(* abs_thm("abs_rev_exhaust_aux", rev_exhaust_aux);
   FIXME: Value or constructor (rev_exhaust_aux) has not been declared
*)

abs_thm("abs_rev_exhaust", rev_exhaust);

(* abs_thm("abs_rev_cases", rev_cases);
   FIXME: Value or constructor (rev_cases) has not been declared
*)

abs_thm("abs_finite_set", finite_set);

abs_thm("abs_set_append", set_append);

abs_thm("abs_set_subset_Cons", set_subset_Cons);

abs_thm("abs_set_empty", set_empty);

abs_thm("abs_set_rev", set_rev);

abs_thm("abs_set_map", set_map);

(* abs_thm("abs_set_filter", set_filter);
   FIXME: *** Unknown theorem "Set.mem_Collect_eq_iff2"
*)

(* abs_thm("abs_set_upt", set_upt);
   FIXME: *** Unknown theorem "Set.mem_Collect_eq_iff2"
*)

(* abs_thm("abs_in_set_conv_decomp", in_set_conv_decomp);
   FIXME: *** Unknown theorem "List.self_append_conv2_iff2"
*)

abs_thm("abs_in_lists_conv_set", in_lists_conv_set);

(* ** New lemmas Isabelle 2003  ** *)

abs_thm("abs_listsD", in_listsD);

abs_thm("abs_listsE", in_listsI); 

(* bind_thm("abs_finite_list", (thm "finite_list"));
   FIXME: *** Unknown theorem(s) "finite_list"
*)

(* abs_thm("abs_set_mem_eq", set_mem_eq); 
   FIXME: Value or constructor (set_mem_eq) has not been declared 
 *)

(* abs_thm("abs_list_all_conv", list_all_conv);
   FIXME: Value or constructor (list_all_conv) has not been declared
*)

abs_thm("abs_list_all_append", list_all_append);

abs_thm("abs_filter_append", filter_append);

abs_thm("abs_filter_filter", filter_filter);

abs_thm("abs_filter_True", filter_True);

abs_thm("abs_filter_False", filter_False); 

(* abs_thm("abs_length_filter", length_filter);
   FIXME: Value or constructor (length_filter) has not been declared
 *)

(* abs_thm("abs_filter_is_subset", filter_is_subset);
   FIXME: *** Unknown theorem "Set.mem_Collect_eq_iff1"
 *)

abs_thm("abs_concat_append", concat_append);

abs_thm("abs_concat_eq_Nil", concat_eq_Nil_conv);

abs_thm("abs_Nil_eq_concat_conv", Nil_eq_concat_conv);

abs_thm("abs_set_concat", set_concat);

abs_thm("abs_map_concat", map_concat);

abs_thm("abs_filter_concat", filter_concat);

abs_thm("abs_rev_concat", rev_concat);

abs_thm("abs_nth_Cons_0", nth_Cons_0);

abs_thm("abs_nth_Cons_Suc", nth_Cons_Suc);

abs_thm("abs_nth_append", nth_append);

abs_thm("abs_nth_map", nth_map);

(* abs_thm("abs_set_conv_nth", set_conv_nth);
   FIXME: *** Unknown theorem "Set.mem_Collect_eq_iff2"
*)

abs_thm("abs_list_ball_nth", list_ball_nth);

abs_thm("abs_nth_mem", nth_mem);

abs_thm("abs_all_nth_imp_all_set", all_nth_imp_all_set);

abs_thm("abs_all_set_conv_all_nth", all_set_conv_all_nth);

abs_thm("abs_length_list_update", length_list_update);

abs_thm("abs_nth_list_update", nth_list_update);

abs_thm("abs_nth_list_update_eq", nth_list_update_eq);

abs_thm("abs_nth_list_update_neq", nth_list_update_neq); 

abs_thm("abs_list_update_overwrite", list_update_overwrite);

abs_thm("abs_list_update_same_conv", list_update_same_conv);

abs_thm("abs_update_zip", update_zip);

abs_thm("abs_update_subset_insert", set_update_subset_insert);

abs_thm("abs_set_update_subsetI", set_update_subsetI);

abs_thm("abs_last_snoc", last_snoc);

abs_thm("abs_butlast_snoc", butlast_snoc);

abs_thm("abs_length_butlast", length_butlast);

abs_thm("abs_butlast_append", butlast_append);

abs_thm("abs_append_butlast_last_id", append_butlast_last_id);

abs_thm("abs_in_set_butlastD", in_set_butlastD);

(* abs_thm("abs_in_set_butlast_appendI", in_set_butlast_appendI);
   FIXME: *** Unknown theorem "List.in_set_butlastD_dest"
 *)   

abs_thm("abs_take_0", take_0);

abs_thm("abs_drop_0", drop_0);

abs_thm("abs_take_Suc_Cons", take_Suc_Cons);

abs_thm("abs_drop_Suc_Cons", drop_Suc_Cons); 

(* abs_thm("abs_take_Suc_conv_app_nth", (thm "take_Suc_conv_app_nth"));
   FIXME: *** Unknown theorem(s) "take_Suc_conv_app_nth"
 *)

abs_thm("abs_length_take", length_take);

abs_thm("abs_length_drop", length_drop);

abs_thm("abs_take_all", take_all);

abs_thm("abs_drop_all", drop_all);

abs_thm("abs_take_append", take_append);

abs_thm("abs_drop_append", drop_append);

abs_thm("abs_take_take", take_take);

abs_thm("abs_drop_drop", drop_drop); 

abs_thm("abs_take_drop", take_drop);

abs_thm("abs_append_take_drop_id", append_take_drop_id);

abs_thm("abs_take_map", take_map);

abs_thm("abs_drop_map", drop_map);

abs_thm("abs_rev_take", rev_take);

abs_thm("abs_rev_drop", rev_drop);

(* abs_thm("abs_nth_take", nth_take);
   FIXME: *** Unknown theorem "Nat.not_less0_iff"
 *)

abs_thm("abs_nth_drop", nth_drop);

abs_thm("abs_append_eq_conv_conj", append_eq_conv_conj);

abs_thm("abs_takeWhile_dropWhile_id", takeWhile_dropWhile_id);

abs_thm("abs_takeWhile_append1", takeWhile_append1);

abs_thm("abs_takeWhile_append2", takeWhile_append2);

abs_thm("abs_takeWhile_tail", takeWhile_tail);

abs_thm("abs_dropWhile_append1", dropWhile_append1);

abs_thm("abs_dropWhile_append2", dropWhile_append2);

abs_thm("abs_set_take_whileD", set_take_whileD);

abs_thm("abs_takeWhile_eq_all_conv", (thm "takeWhile_eq_all_conv"));

abs_thm("abs_dropWhile_eq_Nil_conv", (thm "dropWhile_eq_Nil_conv"));

abs_thm("abs_dropWhile_eq_Cons_conv", (thm "dropWhile_eq_Cons_conv"));

abs_thm("abs_zip_Nil", zip_Nil);

abs_thm("abs_zip_Cons_Cons", zip_Cons_Cons);

abs_thm("abs_length_zip", length_zip);

abs_thm("abs_zip_append1", zip_append1);

abs_thm("abs_zip_append2", zip_append2);

abs_thm("abs_zip_append", zip_append);

abs_thm("abs_zip_rev", zip_rev);

abs_thm("abs_nth_zip", nth_zip);

abs_thm("abs_set_zip", set_zip);

abs_thm("abs_zip_update", zip_update);

abs_thm("abs_zip_replicate", zip_replicate);

abs_thm("abs_list_all2_lengthD", list_all2_lengthD);

abs_thm("abs_list_all2_Nil", list_all2_Nil); 

abs_thm("abs_list_all2_Nil2", list_all2_Nil2);

(* abs_thm("abs_list_all2_Cons", list_all2_Cons);
   FIXME: *** Unknown theorem "Product_Type.Pair_eq_iff1"
 *)

abs_thm("abs_list_all2_Cons1", list_all2_Cons1);

abs_thm("abs_list_all2_Cons2", list_all2_Cons2);

abs_thm("abs_list_all2_rev", list_all2_rev);

abs_thm("abslist_all2_rev1", (thm "list_all2_rev1"));

(* abs_thm("abs_list_all2_append1", list_all2_append1);
   FIXME: diverges??
 *)

(* abs_thm("abs_list_all2_append2", list_all2_append2);
   FIXME: diverges?? 
 *)

abs_thm("abs_list_all2_append", (thm "list_all2_append"));

abs_thm("abs_list_all2_appendI", (thm "list_all2_appendI"));

abs_thm("abs_list_all2_conv_all_nth", list_all2_conv_all_nth);

abs_thm("abs_list_all2_trans", list_all2_trans);

(* FIXME: *** Unknown theorem(s):

   abs_thm("abs_list_all2_all_nthI", (thm "list_all2_all_nthI"));

   abs_thm("abs_list_all2_nthD", (thm "list_all2_nthD"));

   abs_thm("abs_list_all2_map1", (thm "list_all2_map1"));

   abs_thm("abs_list_all2_map2", (thm "list_all2_map2"));

   abs_thm("abs_list_all2_refl", (thm "list_all2_refl"));

   abs_thm("abs_list_all2_update_cong", (thm "list_all2_update_cong"));

   abs_thm("abs_list_all2_update_cong2", (thm "list_all2_update_cong2"));

   abs_thm("abs_list_all2_dropI", (thm "list_all2_dropI"));

   abs_thm("abs_list_all2_mono", (thm "list_all2_mono"));

*)


abs_thm("abs_foldl_append", foldl_append);

abs_thm("abs_start_le_sum", start_le_sum);

abs_thm("abs_elem_le_sum", elem_le_sum);

abs_thm("abs_sum_eq_0_conv", sum_eq_0_conv); 

abs_thm("abs_upt_rec", upt_rec);

abs_thm("abs_upt_conv_Nil", upt_conv_Nil);

abs_thm("abs_upt_Suc_append", upt_Suc_append);

abs_thm("abs_upt_conv_Cons", upt_conv_Cons);

abs_thm("abs_upt_add_eq_append", upt_add_eq_append);

abs_thm("abs_length_upt", length_upt); 

(* abs_thm("abs_nth_upt", nth_upt);  
   FIXME: *** Unknown theorem "Nat.not_add_less1_iff"
*)

abs_thm("abs_take_upt", take_upt); 

abs_thm("abs_map_Suc_upt", map_Suc_upt);

abs_thm("abs_nth_map_upt", nth_map_upt);

abs_thm("abs_nth_take_lemma", nth_take_lemma);

abs_thm("abs_nth_equalityI", nth_equalityI);

(* abs_thm("abs_list_all2_antisym", (thm "list_all2_antisym"));
   FIXME: *** Unknown theorem(s) "list_all2_antisym"
 *)

abs_thm("abs_take_equalityI", take_equalityI);

abs_thm("abs_distinct_append", distinct_append); 

abs_thm("abs_set_remdups", set_remdups); 

abs_thm("abs_distinct_remdups", distinct_remdups);

abs_thm("abs_distinct_filter", distinct_filter);

(* abs_thm("abs_distinct_conv_nth",  (thm "distinct_conv_nth"));
   FIXME:  *** Unknown theorem(s) "distinct_conv_nth" 
 *)

abs_thm("abs_length_replicate", length_replicate);

abs_thm("abs_map_replicate", map_replicate);

abs_thm("abs_replicate_app_Cons_same", replicate_app_Cons_same);

abs_thm("abs_rev_replicate", rev_replicate);

abs_thm("abs_replicate_add", replicate_add);

abs_thm("abs_hd_replicate", hd_replicate);

abs_thm("abs_tl_replicate", tl_replicate);


(* abs_thm("abs_last_replicate", last_replicate);
   FIXME: *** Unknown theorem "Nat.not_gr0_iff1"
 *)

abs_thm("abs_nth_replicate", nth_replicate);

abs_thm("abs_set_replicate_Suc", (thm "set_replicate_Suc"));

(* abs_thm("abs_set_replicate", set_replicate);
   FIXME: *** Unknown theorem "Nat.not0_implies_Suc_dest"
 *)

abs_thm("abs_set_replicate_conv_if", set_replicate_conv_if);

abs_thm("abs_in_set_replicateD", in_set_replicateD);

(* abs_thm("abs_wf_lexn", wf_lexn);
   FIXME: *** Unknown theorem "List.list.inject_iff1"
*)

abs_thm("abs_lexn_length", lexn_length);

(* abs_thm("abs_wf_lex", wf_lex);
   FIXME: *** Unknown theorem "List.lexn_length_dest"
*)

(* abs_thm("abs_lexn_conv", lexn_conv);
   FIXME: *** Unknown theorem "Set.mem_Collect_eq_iff1"
*)

(* abs_thm("abs_lex_conv", lex_conv);
   FIXME: *** Unknown theorem "Set.mem_Collect_eq_iff1"
*)

(* abs_thm("abs_wf_lexico", wf_lexico);
   FIXME: Value or constructor (wf_lexico) has not been declared
 *)

(* abs_thm("abs_lexico_conv", lexico_conv);
   FIXME: Value or constructor (lexico_conv) has not been declared
 *)

abs_thm("abs_Nil_notin_lex", Nil_notin_lex);

abs_thm("abs_Nil2_notin_lex", Nil2_notin_lex);

(* abs_thm("abs_Cons_in_lex", Cons_in_lex);
   FIXME: *** Unknown theorem "List.self_append_conv2_iff2"
 *)

abs_thm("abs_sublist_empty", sublist_empty);

abs_thm("abs_sublist_nil", sublist_nil);

abs_thm("abs_sublist_shift_lemma", sublist_shift_lemma);

abs_thm("abs_sublist_append", sublist_append);

abs_thm("abs_sublist_Cons", sublist_Cons);

abs_thm("abs_sublist_singleton", sublist_singleton);

abs_thm("abs_sublist_upt_eq_take", sublist_upt_eq_take);

abs_thm("abs_take_Cons'", take_Cons');

abs_thm("abs_drop_Cons'", drop_Cons');

abs_thm("abs_nth_Cons'", nth_Cons');


writeln "\n\nAbstraction complete\n\n";
