(* Shouldn't really be necessary?! *)
val thy = the_context ();

(* Some preliminary properties *)
Goal "!!ys. bPlus Zero ys = ys";
by (induct_tac "ys" 1); auto(); qed "bPlus_Zero";

Goal "bSucc x ~= Zero";
by (induct_tac "x" 1);auto(); qed "succNotZero1";

Goal "Zero ~= bSucc x";
by (induct_tac "x" 1); auto(); qed "succNotZero2";

Goal "bPlus x Zero = x";
by (induct_tac "x" 1); auto(); qed "bPlusZeroZero";

Goal "PBin (pPlus x y) = bPlus (PBin x) (PBin y)";
auto(); qed "PBinPlusCommute";

Goal "pPlus x One = pSucc x";
by(induct_tac "x" 1); auto(); qed "pPluspSuccOne";

Goal "!y. pPlus (pSucc x) y = pPlus x (pSucc y)";
by(induct_tac "x" 1); auto(); 
by(case_tac "y" 3); by(case_tac "y" 2); by(case_tac "y" 1); auto();
Addsimps [pPluspSuccOne]; auto(); Delsimps [pPluspSuccOne];
qed "pPluspSuccx";

Goal "!y. pPlus (pSucc x) y = pSucc (pPlus x y)";
by (induct_tac "x" 1);auto();
by (case_tac "y" 1); auto();
by (case_tac "y" 1); auto();
Addsimps [pPluspSuccx]; auto(); Delsimps [pPluspSuccx];
by (case_tac "y" 1); auto();
qed "pPlussPsuccComm";

Goal "!y. pPlus x y = pPlus y x";
by(induct_tac "x" 1); auto();
Addsimps [pPluspSuccOne]; auto(); Delsimps [pPluspSuccOne];
by(case_tac "y" 1); auto();
Addsimps [pPluspSuccx]; auto(); Delsimps [pPluspSuccx];
qed "pPlus_comm";

Goal "bPlus (bSucc x) y = bSucc (bPlus x y)";
by(induct_tac "x" 1); auto();
by(case_tac "y" 1); auto();
by(case_tac "y" 1); 
Addsimps [pPlussPsuccComm]; auto(); Delsimps [pPlussPsuccComm];
qed "bPlus_bSucc";

Goal "pPlus x (pSucc y)= pSucc (pPlus x y)";
br trans 1; br ((pPluspSuccx RS spec) RS sym) 1;
br trans 1; br (pPlussPsuccComm RS spec) 1; auto();
qed "pPlusPsucc";

Goal "bPlus x (bSucc y) = bSucc (bPlus  x y)";
by(induct_tac "x" 1); auto();
by(case_tac "y" 1); auto();
Addsimps [pPlusPsucc, pPluspSuccOne]; auto(); 
Delsimps [pPlusPsucc,pPluspSuccOne];
qed "bPlusSucc";

Goal "pPlus x x = Bit x False";
by (induct_tac "x" 1);auto();
Addsimps [pPlusPsucc]; auto(); Delsimps [pPlusPsucc];
qed "pPlusXX";

Goal "bPlus (PBin x) (PBin x) = PBin (Bit x False)";
by (induct_tac "x" 1);auto();
Addsimps [pPlusPsucc]; auto(); Delsimps [pPlusPsucc];
qed "bPlusXX";

Goal "b2n (bSucc b) = Suc (b2n b)";
by(induct_tac "b" 1); auto();
by(induct_tac "Pos" 1); auto();
qed "bSucc_Suc";

Goal "n2b (x + y) = bPlus (n2b x) (n2b y)";
by(induct_tac "x" 1); auto();
by(induct_tac "y" 1); auto();
Addsimps [pPlussPsuccComm,bPlusSucc]; auto(); 
Delsimps [pPlussPsuccComm,bPlusSucc];
Addsimps [bPlusZeroZero];auto(); Delsimps [bPlusZeroZero];
qed "BitPluss";

Goal "pPlus (pSucc x) x = Bit x True";
Addsimps [pPlussPsuccComm]; auto(); Delsimps [pPlussPsuccComm];
Addsimps [pPlusXX]; auto();Delsimps [pPlusXX];
qed "succFalseTrue";

(*
Goal "Bit (pPlus x y) b = pPlus x (pPlus x (Bit y b))";
by(induct_tac "y" 1);
Addsimps [pPluspSuccOne]; auto(); Delsimps [pPluspSuccOne];
*)


Goal "(One ~= pSucc x)";
by(case_tac "x" 1); auto(); qed "One_not_pSucc1";

Goal "(pSucc x ~= One)";
by(case_tac "x" 1); auto(); qed "One_not_pSucc2";

Goal "!y. (pSucc x = pSucc y --> x = y)";
by(induct_tac "x" 1); auto();
by(case_tac "y" 1); auto();
by(case_tac "bool" 1); auto();
Addsimps [One_not_pSucc1]; auto(); Delsimps [One_not_pSucc1];
by(case_tac "y" 1); auto();
Addsimps [One_not_pSucc2]; auto(); Delsimps [One_not_pSucc2];
by(case_tac "boola" 1); auto();
by(case_tac "boola" 1); auto();
by(case_tac "y" 1); auto();
by(case_tac "boola" 1); auto();
qed "pSucc_eq_pSucc";

Goal "! y. (bSucc x = bSucc y --> x = y)";
by(induct_tac "x" 1);auto();
by(case_tac "y" 1);auto();
Addsimps [One_not_pSucc1]; auto(); Delsimps [One_not_pSucc1];
by(case_tac "y" 1); auto();
Addsimps [One_not_pSucc2]; auto(); Delsimps [One_not_pSucc2];
br ((pSucc_eq_pSucc RS spec) RS mp) 1; auto();
qed_spec_mp "bSucc_inj";

Goal "(b2n (n2b n)) = n";
by(induct_tac "n" 1); auto();
Addsimps [bSucc_Suc]; auto(); Delsimps [bSucc_Suc];
qed "b2n2b"; 

Goal "n2b (b2n b) = b";
by(induct_tac "b" 1); auto();
by(induct_tac "Pos" 1); auto();
Addsimps [BitPluss,pPlusXX,succFalseTrue]; auto();
Delsimps [BitPluss,pPlusXX,succFalseTrue];
qed "n2b2n";

Goal "? n . (n2b n) = b";
br exI 1; 
by (instantiate_tac [("n", "b2n b")]);
Addsimps [n2b2n]; auto(); Delsimps [n2b2n];
qed "allNs_are_Bs";


goal thy "[|P Zero; !!x. P x ==> P (bSucc x)|] ==> P x";
val [prem_0, prem_succ] = premises();
br subst 1; back(); br n2b2n 1;
br (thm "Nat.nat.induct") 1;
auto(); 
br prem_0 1;
br prem_succ 1; ba 1;
qed "bNatInduct";
