
(* What theorems do we depend on? *)
val deps = Inspect.dep_thms_not_in DStruct.thy stack_ref;

(* Make assumptions explicit *)
val thm0 = AbsTac.abs_thms deps stack_ref;

val depops = Inspect.dep_ops_not_in DStruct.thy thm0;
val thm4 = AbsTac.abs_ops depops thm0;
(*
val thm1 = AbsTac.rep_ops_thy StackRef.thy thm0;
val thm2 = AbsTac.rep_ops_thy DataRef.thy thm1;
val thm3 = AbsTac.rep_ops_thy ArrayStack.thy thm2;
val thm4 = AbsTac.rep_ops_thy ListStack.thy thm3;
*)

val nuthy= theory_of_thm thm4;
val absthm = Abstract.abstract_type nuthy (Type("IntDef.int", [])) 
                                          ("a", ["HOL.type"]) thm4;


(* ----------------------------------------------------------------------
 * Resulting theorem: 

>ML val absthm =
  "[| ?pc3.0 ?r ?ltop ?atop; ?pc3.0 ?r ?lpop ?apop; ?pc3.0 ?r ?lpush ?apush;
      ?pc2.0 ?r ?ltop ?atop; ?pc2.0 ?r ?lpop ?apop; ?pc2.0 ?r ?lpush ?apush;
      !!u. ?aops u == case u of push => ?apush | pop => ?apop | top => ?atop;
      !!u. ?lops u == case u of push => ?lpush | pop => ?lpop | top => ?ltop;
      ?lempty == {(g, l). l = []}; ?aempty == {(g, l). l = (0, empty)};
      ?ls == (?lempty, ?lops); ?as == (?aempty, ?aops);
      !!r ai ci.
         ?pc1.0 r ai ci == ALL (g, c):ci. EX a. (g, a) : ai & (a, c) : r;
      ?r ==
      {(l, p, a).
       p = length l & (ALL i. 0 <= i & i < p --> l ! i = the (a (p - i - 1)))};
      !!c a.
         ?refines c a ==
         EX r.
            let cinit = fst c; cops = snd c; ainit = fst a; aops = snd a
            in ?pc1.0 r ainit cinit &
               (ALL i. ?pc2.0 r (aops i) (cops i)) &
               (ALL i. ?pc3.0 r (aops i) (cops i)) |] ==> ?refines ?as ?ls"
  : thm
ML> show_types := true;
val it = () : unit
ML> absthm;
val it =
  "[| (?pc3.0::[(?a list * nat * (nat => ?a option)) set,
               (((?a * ?a) * ?a list) * (?a * ?a) * ?a list) set,
               (((?a * ?a) * nat * (nat => ?a option)) *
                (?a * ?a) * nat * (nat => ?a option)) set] => bool)
       (?r::(?a list * nat * (nat => ?a option)) set)
       (?ltop::(((?a * ?a) * ?a list) * (?a * ?a) * ?a list) set)
       (?atop::(((?a * ?a) * nat * (nat => ?a option)) *
                (?a * ?a) * nat * (nat => ?a option)) set);
      ?pc3.0 ?r (?lpop::(((?a * ?a) * ?a list) * (?a * ?a) * ?a list) set)
       (?apop::(((?a * ?a) * nat * (nat => ?a option)) *
                (?a * ?a) * nat * (nat => ?a option)) set);
      ?pc3.0 ?r (?lpush::(((?a * ?a) * ?a list) * (?a * ?a) * ?a list) set)
       (?apush::(((?a * ?a) * nat * (nat => ?a option)) *
                 (?a * ?a) * nat * (nat => ?a option)) set);
      (?pc2.0::[(?a list * nat * (nat => ?a option)) set,
               (((?a * ?a) * ?a list) * (?a * ?a) * ?a list) set,
               (((?a * ?a) * nat * (nat => ?a option)) *
                (?a * ?a) * nat * (nat => ?a option)) set] => bool) ?r ?ltop
       ?atop; ?pc2.0 ?r ?lpop ?apop; ?pc2.0 ?r ?lpush ?apush;
      !!u::i.
         (?aops::i
                 => (((?a * ?a) * nat * (nat => ?a option)) *
                     (?a * ?a) * nat * (nat => ?a option)) set) u ==
         case u of push => ?apush | pop => ?apop | top => ?atop;
      !!u::i.
         (?lops::i => (((?a * ?a) * ?a list) * (?a * ?a) * ?a list) set) u ==
         case u of push => ?lpush | pop => ?lpop | top => ?ltop;
      ?lempty::((?a * ?a) * ?a list) set == {(g::?a * ?a, l::?a list). l = []};
      ?aempty::((?a * ?a) * nat * (nat => ?a option)) set ==
      {(g::?a * ?a, l::nat * (nat => ?a option)). l = (0::nat, empty)};
      ?ls::((?a * ?a) * ?a list) set *
           (i => (((?a * ?a) * ?a list) * (?a * ?a) * ?a list) set) ==
      (?lempty, ?lops);
      ?as::((?a * ?a) * nat * (nat => ?a option)) set *
           (i
            => (((?a * ?a) * nat * (nat => ?a option)) *
                (?a * ?a) * nat * (nat => ?a option)) set) == (?aempty, ?aops);
      !!(r::(?a list * nat * (nat => ?a option)) set)
         (ai::((?a * ?a) * ?a list) set)
         ci::((?a * ?a) * nat * (nat => ?a option)) set.
         (?pc1.0::[(?a list * nat * (nat => ?a option)) set,
                  ((?a * ?a) * ?a list) set,
                  ((?a * ?a) * nat * (nat => ?a option)) set] => bool) r ai
          ci ==
         ALL (g::?a * ?a, c::nat * (nat => ?a option)):ci.
            EX a::?a list. (g, a) : ai & (a, c) : r;
      ?r ==
      {(l::?a list, p::nat, a::nat => ?a option).
       p = length l &
       (ALL i::nat.
           (0::nat) <= i & i < p --> l ! i = the (a (p - i - (1::nat))))};
      !!(c::((?a * ?a) * nat * (nat => ?a option)) set *
            (i
             => (((?a * ?a) * nat * (nat => ?a option)) *
                 (?a * ?a) * nat * (nat => ?a option)) set))
         a::((?a * ?a) * ?a list) set *
            (i => (((?a * ?a) * ?a list) * (?a * ?a) * ?a list) set).
         (?refines::[((?a * ?a) * nat * (nat => ?a option)) set *
                     (i
                      => (((?a * ?a) * nat * (nat => ?a option)) *
                          (?a * ?a) * nat * (nat => ?a option)) set),
                    ((?a * ?a) * ?a list) set *
                    (i => (((?a * ?a) * ?a list) * (?a * ?a) * ?a list) set)]
                    => bool) c a ==
         EX r::(?a list * nat * (nat => ?a option)) set.
            let cinit::((?a * ?a) * nat * (nat => ?a option)) set = fst c;
                cops::i
                      => (((?a * ?a) * nat * (nat => ?a option)) *
                          (?a * ?a) * nat * (nat => ?a option)) set = snd c;
                ainit::((?a * ?a) * ?a list) set = fst a;
                aops::i => (((?a * ?a) * ?a list) * (?a * ?a) * ?a list) set =
                  snd a
            in ?pc1.0 r ainit cinit &
               (ALL i::i. ?pc2.0 r (aops i) (cops i)) &
               (ALL i::i. ?pc3.0 r (aops i) (cops i)) |] ==> ?refines ?as ?ls"
  : thm
ML>

*)
