
theory ListMon imports Main
begin

use_thy Monad

thymorph t : MonadType \<longrightarrow> ListMon
maps [("'a M" \<mapsto> "'a list")]

t_instantiate MonadOps mapping t

defs
list_eta_def : "eta x \<equiv> [x]"

primrec
"([] >>= f) = []"
"((x#xs) >>= f) = ((f x)@(xs >>= f))"


t_instantiate MonadAxms mapping t'


lemma bind_concat : " (l >>= f) = (concat (map f l)) " by (induct l, simp_all)

lemma lunit : " (eta x >>= t) = t x " by (simp add: list_eta_def)

lemma runit : " (t >>= eta) = t " by (induct t, simp_all add: list_eta_def)

lemma assoc : " ((s >>= t) >>= u) = (s >>= (\<lambda> x. (t x >>= u))) "
by (simp add: bind_concat, induct s, simp_all)

lemma eta_inj : " eta x = eta y \<Longrightarrow> x = y " by (simp add: list_eta_def)


thymorph t by_sigmorph t''

t_instantiate Monad mapping t

translate_thm "Monad.mapF_joinM'" as "" along t'
translate_thm "Monad.lift_eta" as "" along t'
translate_thm "Monad.lift2_eta" as "" along t'
translate_thm "Monad.lift3_eta" as "" along t'
translate_thm "Monad.lift_eta2" as "" along t'


end

